#include <windows.h>
#include <stdio.h>
#pragma hdrstop
#define err doerr( __FILE__, __LINE__ )
void doerr( const char *file, int line )
 {
  DWORD e;
  e = GetLastError();
  if ( e == 0 )
   return;
   printf( "%s(%d): gle = %lu\n", file, line, e );
   exit( 2 );
 }
void enableprivs()
 {
  // 00401040
   // push ebp
   // mov ebp,esp
   // sub esp,2C
   // mov eax,dword ptr ds:[40C004]
  HANDLE hToken;
  byte buf[sizeof TOKEN_PRIVILEGES * 2];
  TOKEN_PRIVILEGES & tkp = *( (TOKEN_PRIVILEGES *) buf );
  if ( ! OpenProcessToken( GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken ) )
   // 00401059
   err;
   // enable SeBackupPrivilege, SeRestorePrivilege
  if ( !LookupPrivilegeValue( NULL, SE_BACKUP_NAME, &tkp.Privileges[0].Luid ) )
   // 0040107C
   err;
  if ( !LookupPrivilegeValue( NULL, SE_RESTORE_NAME, &tkp.Privileges[1].Luid ) )
   // 004010A3
   err;
   tkp.PrivilegeCount = 2;
   tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
   tkp.Privileges[1].Attributes = SE_PRIVILEGE_ENABLED;
   AdjustTokenPrivileges( hToken, FALSE, &tkp, sizeof tkp, NULL, NULL );
 }
void dumphdr( WIN32_STREAM_ID & wsi )
 // 00401110
  // push ebp
  // mov ebp,esp
  // sub esp,0C
 {
  const char *p;
  printf( "\nstream [%lu] \"%S\":\n", wsi.dwStreamNameSize, wsi.dwStreamNameSize? wsi.cStreamName: L"" );
   // 00401116
    // mov eax,dword ptr ss:[ebp+8]
    // cmp dword ptr ds:[eax+10],0
    // je short 0040112A
    // mov ecx,dword ptr ss:[ebp+8]
    // add ecx,14
    // mov dword ptr ss:[ebp-8],ecx
    // jmp short 00401131
    // mov dword ptr ss:[ebp-8],0040A1FC
    // mov edx,dword ptr ss:[ebp-8]
    // push edx
     // :Zone.Identifier:$DATA
    // mov eax,dword ptr ss:[ebp+8]
    // mov ecx,dword ptr ds:[eax+10]
    // push ecx
    // push 0040A200
     // stream [%lu] "%S":
    // call 004016C8
    // add esp,0C
    // mov edx,dword ptr ss:[ebp+8]
    // mov eax,dword ptr ds:[edx]
    // mov dword ptr ss:[ebp-C],eax
    // mov ecx,dword ptr ss:[ebp-C]
    // sub ecx,1
    // mov dword ptr ss:[ebp-C],ecx
  switch ( wsi.dwStreamId )
   {
    case BACKUP_DATA:
     p = "data";
     break;
    case BACKUP_EA_DATA:
     p = "extended attributes";
     break;
    case BACKUP_SECURITY_DATA:
     p = "security";
     break;
    case BACKUP_ALTERNATE_DATA:
     // 0040115A
      // cmp dword ptr ss:[ebp-C],4
      // ja short 00401197
      // mov edx,dword ptr ss:[ebp-C]
      // jmp dword ptr ds:[edx*4+4011CC]
     p = "other streams";
      // 00401185
       // mov dword ptr ss:[ebp-4],0040A240
        // 0040A240
         // other streams
       // jmp short 0040119E
     break;
    case BACKUP_LINK:
     p = "link";
     break;
    default:
     p = "unknown";
     break;
   }
  printf( "  type: %s\n", p );
   // 0040119E
    // mov eax,dword ptr ss:[ebp-4]
    // push eax
     // eax
      // other streams
    // push 0040A260
     //   type: %s
    // call 004016C8
    // add esp,8
  printf( "  size: %I64d\n", wsi.Size.QuadPart );
   // 004011AF
    // mov ecx,dword ptr ss:[ebp+8]
    // mov edx,dword ptr ds:[ecx+C]
    // push edx
    // mov eax,dword ptr ds:[ecx+8]
     // Stack ds:[0012EF28]
      // 0000001Ah
       // 26d
    // push eax
    // push 0040A26C
    // call 004016C8
    // add esp,0C
 }
  // 004011C7
   // mov esp,ebp
   // pop ebp
   // retn
int main(int argc,char *argv[])
 {
  //0040197D
   //push eax
   //push dword ptr ds:[40CF9C]
   //push dword ptr ds:[40CF98]
   //call 004011E0
	HANDLE fh;
	if(argc!=2)
     //004011F7
      //cmp dword ptr ss:[ebp+8],2
      //je short 00401214
     {
      printf("usage: dump_ntfs_streams {file}\n");
      return 1;
     }
    //SeBackupPrivilege is not necessary to enumerate streams --
    //but it helps if you are an admin/backup-operator and need
    //to scan files to which you have no permissions
    enableprivs();
     //00401214
      //call 00401040
    fh=CreateFile(argv[1],GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_FLAG_BACKUP_SEMANTICS|FILE_FLAG_POSIX_SEMANTICS,NULL);
     //00401219
    if(fh==INVALID_HANDLE_VALUE||fh==NULL)
     //0040123E
     err;
    byte buf[4096];
    DWORD numread,numtoskip;
     //DWORD is must upcase.
    void *ctx=NULL;
    WIN32_STREAM_ID&wsi=*((WIN32_STREAM_ID*)buf);
    numtoskip=0;
    while(1)
     //00401276
      //mov eax,1
      //test eax,eax
      //je 0040136D
     {
      //we are at the start of a stream header. read it.
      if(!BackupRead(fh,buf,20,&numread,FALSE,TRUE,&ctx))
       //00401283
        //lea ecx,dword ptr ss:[ebp-8]
        //push ecx
        //push 1
        //push 0
        //lea edx,dword ptr ss:[ebp-10]
        //push edx
        //push 14
        //lea eax,dword ptr ss:[ebp-1018]
        //push eax
        //mov ecx,dword ptr ss:[ebp-101C]
        //push ecx
        //call dword ptr ds:[<&KERNEL32.BackupRead>]
        //test eax,eax
        //jnz short 004012B8
       err;
        //004012A9
         //push 75
         //push 0040A2B8
         //call 00401000
         //add esp,8
       if ( numread == 0 )
        // 004012B8
         // cmp dword ptr ss:[ebp-10],0
         // jnz short 004012C3
        break;
         // 004012BE
          // jmp 0040136D
        if ( wsi.dwStreamNameSize > 0 )
         // 004012C3
          // mov edx,dword ptr ss:[ebp-C]
          // cmp dword ptr ds:[edx+10],0
          // jbe short 00401313
         {
          if ( ! BackupRead( fh, buf + 20, wsi.dwStreamNameSize, &numread, FALSE, TRUE, &ctx ) )
           // 004012CC
            // lea eax,dword ptr ss:[ebp-8]
            // push eax
            // push 1
            // push 0
            // lea ecx,dword ptr ss:[ebp-10]
            // push ecx
            // mov edx,dword ptr ss:[ebp-C]
            // mov eax,dword ptr ds:[edx+10]
            // push eax
            // lea ecx,dword ptr ss:[ebp-1004]
            // push ecx
            // mov edx,dword ptr ss:[ebp-101C]
            // push edx
            // call dword ptr ds:[<&KERNEL32.BackupRead>]
            // test eax,eax
            // jnz short 00401306
           err;
            // 004012F7
             // push 7D
             // push 0040A20
             // call 00401000
             // add esp,8
           if ( numread != wsi.dwStreamNameSize )
            // 00401306
             // mov eax,dword ptr ss:[ebp-C]
             // mov ecx,dword ptr ss:[ebp-10]
             // cmp ecx,dword ptr ds:[eax+10]
             // je short 00401313
            break;
             // 00401311
              // jmp short 0040136D
         }
        dumphdr( wsi );
         // 00401313
          // mov edx,dword ptr ss:[ebp-C]
          // push edx
          // call 00401110
          // add esp,4
        // skip stream data
        if ( wsi.Size.QuadPart > 0 )
         // 0040131F
          // mov eax,dword ptr ss:[ebp-C]
          // mov dword ptr ss:[ebp-1028],eax
          // mov ecx,dword ptr ss:[ebp-1028]
          // cmp dword ptr ds:[ecx+C],0
          // jl short 00401368
          // jg short 00401342
          // mov edx,dword ptr ss:[ebp-1028]
          // cmp dword ptr ds:[edx+8],0
           // condition compare
          // jbe short 00401368
         {
          DWORD lo, hi;
          BackupSeek( fh, 0xffffffffL, 0x7fffffffL, &lo, &hi, &ctx );
           // 00401342
            // lea eax,dword ptr ss:[ebp-8]
            // push eax
            // lea ecx,dword ptr ss:[ebp-1024]
            // push ecx
            // lea edx,dword ptr ss:[ebp-1020]
            // push edx
            // push 7FFFFFFF
            // push -1
            // mov eax,dword ptr ss:[ebp-101C]
            // push eax
            // call dword ptr ds:[<&KERNEL32.BackupSeek>]
         }
          // 00401368
           // jmp 00401276
     }
    // make NT release the context
    BackupRead( fh, buf, 0, &numread, TRUE, FALSE, &ctx );
     // 0040136D
      // lea ecx,dword ptr ss:[ebp-8]
      // push ecx
      // push 0
      // push 1
      // lea edx,dword ptr ss:[ebp-10]
      // push edx
      // push 0
      // lea eax,dword ptr ss:[ebp-1018]
      // push eax
      // mov ecx,dword ptr ss:[ebp-101C]
      // push ecx
      // call dword ptr ds:[<&KERNEL32.BackupRead>]
    CloseHandle( fh );
    return 0;
     // 0040139C
      // xor eax,eax
      // mov ecx,dword ptr ss:[ebp-14]
      // xor ecx,ebp
      // call 0040178D
      // mov esp,ebp
      // pop ebp
      // retn
 }